use Fcntl qw(/^O_/ :flock);

sub template
 {
 # Parametrit:
 # 0: luettava tiedosto
 # 1: mihin tulostetaan (tiedosto tai stdout tai return)
 # 2..: paikallinen parametri-hash
 # return: palautetaan stringin koko roska

 my @arr = @_;

 my $source = shift(@arr);
 my $dest = shift(@arr);
 $dest = "stdout" unless defined $dest;
 my $retval;

 if (lc($dest) eq "stdout") { $dest = "stdout"; }
 if (lc($dest) eq "return") { $dest = "return"; }

 my %xlate = @arr;

 open(S,"<$source") or &vika("Sirkku::template: Could not open $source for input: $!");
 flock(S,LOCK_SH);
 seek S, 0, 0;

 if ($dest ne "stdout" and $dest ne "return") {
   open(D,"+<$dest") or die("template: Could not open $dest for writing: $!");
   flock(D,LOCK_EX);
   seek D, 0, 0;
   truncate D, 0;
 }

 my $line = "";
 my $found = "";

 while ($line = <S>) {

  # Change all tags that are found from the file
  # This replaces known tags with %xlate and unknown tags with "",
  # as they are not defined in %xlate

  do {
    ($found) = ($line =~ /<!--###(.*?)###-->/);   # Search for key
    if ($found ne "") {

      $line =~ s/<!--###$found###-->/$xlate{"$found"}/i;
      }
    } until ((not defined $found) or ($found eq ""));  

  if ($dest eq "stdout") {
    print $line;
    }
  elsif ($dest eq "return") {
	$retval .= $line;
  }
  else {
    print D $line;
    }
  }

 flock(S,LOCK_UN);
 close(S);

 if (($dest ne "stdout") and ($dest ne "return")) {
   flock(D,LOCK_UN);
   close(D);
 }

 return $retval if ($dest eq "return");

 return 1;		# Palauttaa true, jos onnistui
 }	# template


1;
